Bug 133063

Summary: Fix the quirks mode selector matching of the pseudo classes :hover and :active
Product: WebKit Reporter: Benjamin Poulain <benjamin>
Component: New BugsAssignee: Benjamin Poulain <benjamin>
Status: RESOLVED FIXED    
Severity: Normal CC: allan.jensen, commit-queue, esprehn+autocc, glenn, gyuyoung.kim, kling, koivisto, macpherson, menard, syoichi
Priority: P2    
Version: 528+ (Nightly build)   
Hardware: Unspecified   
OS: Unspecified   
Attachments:
Description Flags
Patch
none
Patch koivisto: review+

Description Benjamin Poulain 2014-05-18 22:29:43 PDT
Fix the quirks mode selector matching of the pseudo classes :hover and :active
Comment 1 Benjamin Poulain 2014-05-18 22:54:02 PDT
Created attachment 231677 [details]
Patch
Comment 2 Benjamin Poulain 2014-05-19 15:05:36 PDT
Comment on attachment 231677 [details]
Patch

I got to test Internet Explorer today, it does not follow Firefox.

Let's go with http://quirks.spec.whatwg.org/#the-:active-and-:hover-quirk instead. It is very similar to what we had before.
Comment 3 Benjamin Poulain 2014-05-26 00:24:56 PDT
Created attachment 232064 [details]
Patch
Comment 4 Benjamin Poulain 2014-05-26 00:26:27 PDT
As discussed with Antti on IRC, it is better to follow the spec, especially since the spec is a generalization of our old behavior.
Comment 5 Antti Koivisto 2014-05-26 05:07:32 PDT
Comment on attachment 232064 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=232064&action=review

r=me

> Source/WebCore/css/SelectorChecker.cpp:361
> +    // In quirks mode, a compound selector selector that matches the following conditions must not match elements that would not also match the ':any-link' selector.

The second selector in "a compound selector selector" could use single quotes around it (the original uses italics).

> LayoutTests/ChangeLog:9
> +        The test coverage of :hover and :active was extremly poor.
> +        Those new tests add coverage for the cases fixed by this patch.

Thanks for extensive tests!
Comment 6 Antti Koivisto 2014-05-26 05:24:22 PDT
Comment on attachment 232064 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=232064&action=review

> Source/WebCore/ChangeLog:32
> +        Tests: fast/selectors/active-hover-quirks.html
> +               fast/selectors/active-quirks.html
> +               fast/selectors/hover-quirks.html

It might be good to also land the same tests in standards mode to document the behavior.
Comment 7 Benjamin Poulain 2014-05-26 14:46:19 PDT
Committed r169360: <http://trac.webkit.org/changeset/169360>